/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 24.05.2010
Author  : 
Company : 
Comments: 


Chip type           : ATtiny2313
Clock frequency     : 4,000000 MHz
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 32
*****************************************************/
typedef  unsigned char byte ;
#pragma optsize+
#include <tiny2313.h>
#include <delay.h>
#include <bcd.h>
                       //Array Symbol image
#define a 32
#define b 128
#define c 2
#define d 8               //     
#define e 16
#define f 64
#define g 1
#define DP 4
#define minus Dig[10]
#define grad  Dig[11]
#define probel Dig[12]

   
 

 byte  Dig[13],
          ind [8],  // indicator image
           
          i   ,     // Number symbol on display

          number_razr [8] ,  // data razryadow-zajiganie 
           
          ustan_pinow [8];   // config registra d  na wix chto gorit ,ost na wxod

   void Dig_init()
 { 

  Dig[0] = (a+b+c+d+e+f);   //       
  Dig[1] = (b+c);
  Dig[2] = (a+b+g+e+d);
  Dig[3] = (a+b+g+c+d);
  Dig[4] = (f+g+b+c);
  Dig[5] = (a+f+g+c+d);
  Dig[6] = (a+f+g+c+d+e);
  Dig[7] = (a+b+c);
  Dig[8] = (a+b+c+d+e+f+g);
  Dig[9] = (a+b+c+d+f+g);
  Dig[10] = (g);
  Dig[11] = (a+b+f+g);
  Dig[12]=  0;
  
  number_razr [0]  = ~16;
  number_razr [1]  = ~1;
  number_razr [2]  = ~2;     //  - 0
  number_razr [3]  = ~32;
  number_razr [4]  = 16 ;    //   - 1
  number_razr [5]  = 1   ;
  number_razr [6]  = 2   ;
  number_razr [7]  = 32;
  
  
   ustan_pinow [0]=16;
   ustan_pinow [1]=1;
   ustan_pinow [2]=2;
   ustan_pinow [3]=32;       //  DDR
   ustan_pinow [4]=16;
   ustan_pinow [5]=1;
   ustan_pinow [6]=2;
   ustan_pinow [7]=32;
   
  
  }
                // Timer 0 overflow interrupt service routine
 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
  { 
    // Reinitialize Timer 0 value
  TCNT0=0xF7;
  DDRB=255;
  if (i< 4)
  {
    PORTB=ind[i];   // i-       - 1    0  3-
  }

 else 
   {
   PORTB=~ind[i];   // i-        - 0    4-  7
   }

    DDRD= ustan_pinow [i];
    PORTD= number_razr [i] & 0b00110011 ; //     i- 

  i++ ;                    //  increment
  if (i>7) i=0;          //    if last symbol

 }


              // 1 Wire Bus functions
 #asm
   .equ __w1_port=0x12 ;PORTD
   .equ __w1_bit=6
 #endasm
   #include <1wire.h>
#include <ds18x20_v2.h>

#define MAX_DS18b20 2

byte ds18b20_devices;

byte ds18b20_rom_codes[MAX_DS18b20][9];


                  void main(void)             //  
 {

 unsigned int temp[2];

  byte n , tempb, initResult, sign[2] ; //             -  



   Dig_init();


             // Crystal Oscillator division factor: 1
  #pragma optsize-
  CLKPR=0x80;
  CLKPR=0x00;
  #ifdef _OPTIMIZE_SIZE_
  #pragma optsize+
  #endif
   
           // Timer/Counter 0 initialization
         // Clock source: System Clock
        // Clock value: 3,906 kHz
       // Mode: Normal top=FFh
      // OC0A output: Disconnected
      // OC0B output: Disconnected
  TCCR0A=0x00;
  TCCR0B=0x05;
  TCNT0=0xF7;
  OCR0A=0x00;
  OCR0B=0x00;

                        // Timer(s)/Counter(s) Interrupt(s) initialization
 TIMSK=0x02;

 //#asm("cli")
 
  // initResult = w1_init(); 
   
  initResult =0;
  // ds18b20_devices=w1_search(0xf0,ds18b20_rom_codes);
   
 //#asm("sei")
    

   

               // Determine the number of DS1820 devices                   

   //delay_ms (5000);

 while (1)   
  { 
    if 
         ( initResult  !=0 )
         
   {    
     
      delay_ms (10000);  
     
     for(n=0; n < ds18b20_devices; n++) 
     {  
       
         #asm("cli")                                                                     //   2- 
        temp[n]=ds18b20_temperature(&ds18b20_rom_codes[n][0]) ;
         #asm("sei")
            
      } 
        
     
     
  
   

   for (n=0; n < ds18b20_devices; n++) 
    {                             
                     
      if (temp[n]==0x1000) 
        { //    1000 
                temp[n]=0; 
             
         if (n==0) 
           {    
            
            ind[3]=probel;
            ind[2]=probel;                        //  
            ind[1]=Dig[0];
            
           }
          else
             {                                                   //       T =0
                                      
             ind[7]=probel;
             ind[6]=probel;
             ind[5]=Dig[0];                              
            }
         }                                          
      else 
      
      {
         
          sign[n]=0;
       
         if (temp[n] > 0x1000)
         
          {                                 //    1000             
            temp[n] =4096-temp[n]; 
            sign[n]=1;           //   4096
            
          
           
               } 
                       
            //   "" 
           
           else
           {
            if (n==0)
               {
                 ind[2]=probel;
                 ind[3]=probel;
               }
         
            else 
             {
                ind[6]=probel;
                ind[7]=probel;
              }  
                
             }
                      
         if ((temp[n] & 0x000F) >= 0x0008)
            temp[n] = (temp[n] >> 4) + 1;
         else                                        //      
            temp[n] = (temp[n] >> 4);
                                 
         tempb = bin2bcd((char) temp[n]);
    
         if (n == 0)   
         {         
            ind[1] = Dig[(tempb & 0x0F)];
            
            if ((tempb >> 4) == 0)
             
              {
               if
                   (sign[n]==1)
                         ind[2]=minus;
                else   
                         ind[2]=probel;
               }
                         
            else 
          
              {             
                 ind[2]=Dig[(tempb >> 4)];
               
                 if (sign[n]==1)
                         ind[3]=minus;
                  else
                      ind[3]=probel;
              }           
                                      
         } 
         
         else
         
          {
              
            ind[5] = Dig[(tempb & 0x0F)];
            
            if ((tempb >> 4) == 0)
            
              {
                if 
                    (sign[n]==1)
                         ind[6]=minus;
                else 
                    ind[6]=probel;
               }       
            
            
            else 
            
              {             
                ind[6]=Dig[(tempb >> 4)]; 
               
                   if 
                  
                       (sign[n]==1)
                              ind[7]=minus;
                   else 
                        
                        ind[7]=probel;
                                                                                                             

             }     
          }
      } 
   
   
   
   
   
   
   
   
    }
    
   }
     else 
     {
       DDRB=0;
       #asm("cli")
 
    initResult = w1_init(); 

    ds18b20_devices=w1_search(0xf0,ds18b20_rom_codes);
   
    #asm("sei")
      ind[1]=Dig[ds18b20_devices];
      ind[0]=grad;
      ind[7]=probel;
      ind[2]= Dig[initResult];
      ind[4]=grad;
    
    
    
    
    
    }
   
  }
 }
